<?php

/**
 * rvc_formato_pago_adj actions.
 *
 * @package    inventario
 * @subpackage bloque
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class rvc_formato_pago_adjActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'RVC_FORMATO_PAGO_ADJ'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'RVC_FORMATO_PAGO_ADJ' =>
        array(
            'id' => 'id',
            'id_formato_pago' => 'id_formato_pago',
            'nombre_adjunto' => 'nombre_adjunto',
            'descripcion_adjunto' => 'descripcion_adjunto',
            'adjunto' => 'adjunto',
            'usuario_log' => 'usuario_log',
            'fecha_log' => 'fecha_log',
            'doc_soporte' => 'doc_soporte',
            'fecha_soporte' => 'fecha_soporte'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id'
    ); //campos para el ordenamiento de la consulta


    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'RVC_FORMATO_PAGO_ADJ' =>
        array(
            'id,a' => array('!=' => array(-1)),
            'id,b' => array('=' => array('id')),
            'id_formato_pago' => array('=' => array('id_formato_pago')),
            'doc_soporte' => array('=' => array('doc_soporte')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Para eliminar filas repetidas

    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id'; //identificador de la tabla
    protected $id_names = array('id'); //llave primaria
    protected $field_names = array('id_formato_pago', 'nombre_adjunto', 'descripcion_adjunto', 'adjunto',
        'usuario_log', 'fecha_log', 'doc_soporte', 'fecha_soporte'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'RVC_FORMATO_PAGO_ADJ'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia    
    protected $has_secuencia = false; //si posee secuencia la tabla

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id'; //identificador unico de la tabla

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        $logger = sfContext::getInstance()->getLogger();

        //valor por defecto
        $errors = null;

        $logger->info("Entro a validateAdd");
        $id_formato_pago = $request['id_formato_pago'];
        $nombre_adjunto = $request['nombre_adjunto'];

        /*
         *  Validar la operación, ya sea por SQL
         */
        //sentencia sql
        $sql = <<<EOD
SELECT
    *
FROM RVC_FORMATO_PAGO_ADJ

where
id_formato_pago = $id_formato_pago
and upper(nombre_adjunto) like '%ORDEN%'
and upper(nombre_adjunto) like '%PAGO%' 
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);


        /*
         *  Generar errores en $errors
         */
//        if (count($records) > 0) {
//            $errors['mensaje'] = "Ya existe un adjunto de tipo Orden de Pago no se permiten mas adjuntos, por favor verificar.";
//            $errors['servicio'] = "rvc_formato_pago_adj";
//            $logger->info("Ya existe un adjunto de tipo Orden de Pago no se permiten mas adjuntos, por favor verificar.");
//        }


        /**
         * Consultar tipo rp segun contrato - 20200904
         */
        //sentencia sql
        $sql = <<<EOD
select
id_contrato,
case when sum(anm) > 0 then 1 else 0 end as anm_text,
case when sum(sgr) > 0 then 1 else 0 end as sgr_text

from (

    SELECT
    id_contrato,
    case when tipo_recurso = 0 then 1 else 0 end as anm,
    case when tipo_recurso = 1 then 1 else 0 end as sgr
    
    FROM rvc_rps_cdps_contrato

)

where
id_contrato in (select id_contrato from rvc_formato_pago where id_formato_pago = $id_formato_pago )

group by
id_contrato 
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */
        $anm_text = 0;
        $sgr_text = 0;
        if (count($records) == 0) {
            $errors['mensaje'] = "No hay registro de RPs, por favor verificar.";
            $errors['servicio'] = "rvc_formato_pago_adj";
            $logger->info("No hay registro de RPs, por favor verificar.");
        } else {
            $anm_text = $records[0]['anm_text'];
            $sgr_text = $records[0]['sgr_text'];
        }


        $nombre_adjunto_text = strtoupper($nombre_adjunto);
        $tag_anm = strpos($nombre_adjunto_text, 'ANM');
        $tag_sgr = strpos($nombre_adjunto_text, 'SGR');

        $tag_otro = strpos($nombre_adjunto_text, 'OTRO');
        if ($tag_otro === false) {

            if ($tag_anm !== false) {
                $tag_anm = 1;

                /*
                 *  Generar errores en $errors
                 */
                $logger->info("anm_text:: " . $anm_text);
                $logger->info("tag_anm:: " . $tag_anm);
                if ($anm_text == 1) {
                    if (!($anm_text == 1 && $tag_anm == 1 )) {
                        $errors['mensaje'] = "No aplica el recurso al tipo documento $nombre_adjunto, por favor verificar.";
                        $errors['servicio'] = "rvc_formato_pago_adj";
                        $logger->info("No aplica el recurso al tipo documento $nombre_adjunto, por favor verificar.");
                    }
                }
            }

            if ($tag_sgr !== false) {
                $tag_sgr = 1;

                /*
                 *  Generar errores en $errors
                 */
                $logger->info("sgr_text:: " . $sgr_text);
                $logger->info("tag_sgr:: " . $tag_sgr);
                if ($sgr_text == 1) {
                    if (!($sgr_text == 1 && $tag_sgr == 1 )) {
                        $errors['mensaje'] = "No aplica el recurso al tipo documento $nombre_adjunto, por favor verificar.";
                        $errors['servicio'] = "rvc_formato_pago_adj";
                        $logger->info("No aplica el recurso al tipo documento $nombre_adjunto, por favor verificar.");
                    }
                }
            }
        }


        //sentencia sql
        $sql = <<<EOD
SELECT
    *
FROM RVC_FORMATO_PAGO_ADJ

where
id_formato_pago = $id_formato_pago
and upper(nombre_adjunto) = UPPER('$nombre_adjunto')
and upper(nombre_adjunto) <> 'OTROS'              
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */
        if (count($records) > 0) {
            $errors['mensaje'] = "Ya hay un registro con ese tipo documento $nombre_adjunto, por favor verificar.";
            $errors['servicio'] = "rvc_formato_pago_adj";
            $logger->info("Ya hay un registro con ese tipo documento $nombre_adjunto, por favor verificar.");
        }

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        $logger = sfContext::getInstance()->getLogger();

        //valor por defecto
        $errors = null;

        $logger->info("Entro a validateUpdate");
        $id_formato_pago = $request['id_formato_pago'];
        $nombre_adjunto = $request['nombre_adjunto'];
        $id = $request['id'];

        /*
         *  Validar la operación, ya sea por SQL
         */
        //sentencia sql
        $sql = <<<EOD
SELECT
    *
FROM RVC_FORMATO_PAGO_ADJ

where
id_formato_pago = $id_formato_pago
and upper(nombre_adjunto) like '%ORDEN%'
and upper(nombre_adjunto) like '%PAGO%'
and id != $id 
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);


        /*
         *  Generar errores en $errors
         */
//        if (count($records) > 0) {
//            $errors['mensaje'] = "Ya existe un adjunto de tipo Orden de Pago no se permiten mas adjuntos, por favor verificar.";
//            $errors['servicio'] = "rvc_formato_pago_adj";
//            $logger->info("Ya existe un adjunto de tipo Orden de Pago no se permiten mas adjuntos, por favor verificar.");
//        }


        /**
         * Consultar tipo rp segun contrato - 20200904
         */
        //sentencia sql
        $sql = <<<EOD
select
id_contrato,
case when sum(anm) > 0 then 1 else 0 end as anm_text,
case when sum(sgr) > 0 then 1 else 0 end as sgr_text

from (

    SELECT
    id_contrato,
    case when tipo_recurso = 0 then 1 else 0 end as anm,
    case when tipo_recurso = 1 then 1 else 0 end as sgr
    
    FROM rvc_rps_cdps_contrato

)

where
id_contrato in (select id_contrato from rvc_formato_pago where id_formato_pago = $id_formato_pago )

group by
id_contrato 
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */
        $anm_text = 0;
        $sgr_text = 0;
        if (count($records) == 0) {
            $errors['mensaje'] = "No hay registro de RPs, por favor verificar.";
            $errors['servicio'] = "rvc_formato_pago_adj";
            $logger->info("No hay registro de RPs, por favor verificar.");
        } else {
            $anm_text = $records[0]['anm_text'];
            $sgr_text = $records[0]['sgr_text'];
        }



        $nombre_adjunto_text = strtoupper($nombre_adjunto);
        $tag_anm = strpos($nombre_adjunto_text, 'ANM');
        $tag_sgr = strpos($nombre_adjunto_text, 'SGR');

        $tag_otro = strpos($nombre_adjunto_text, 'OTRO');

        $tag_otro = strpos($nombre_adjunto_text, 'OTRO');
        if ($tag_otro === false) {

            if ($tag_anm !== false) {
                $tag_anm = 1;

                /*
                 *  Generar errores en $errors
                 */
                $logger->info("anm_text:: " . $anm_text);
                $logger->info("tag_anm:: " . $tag_anm);
                if ($anm_text == 1) {
                    if (!($anm_text == 1 && $tag_anm == 1 )) {
                        $errors['mensaje'] = "No aplica el recurso al tipo documento $nombre_adjunto, por favor verificar.";
                        $errors['servicio'] = "rvc_formato_pago_adj";
                        $logger->info("No aplica el recurso al tipo documento $nombre_adjunto, por favor verificar.");
                    }
                }
            }

            if ($tag_sgr !== false) {
                $tag_sgr = 1;

                /*
                 *  Generar errores en $errors
                 */
                $logger->info("sgr_text:: " . $sgr_text);
                $logger->info("tag_sgr:: " . $tag_sgr);
                if ($sgr_text == 1) {
                    if (!($sgr_text == 1 && $tag_sgr == 1 )) {
                        $errors['mensaje'] = "No aplica el recurso al tipo documento $nombre_adjunto, por favor verificar.";
                        $errors['servicio'] = "rvc_formato_pago_adj";
                        $logger->info("No aplica el recurso al tipo documento $nombre_adjunto, por favor verificar.");
                    }
                }
            }
        }


        //sentencia sql
        $sql = <<<EOD
SELECT
    *
FROM RVC_FORMATO_PAGO_ADJ

where
id_formato_pago = $id_formato_pago
and upper(nombre_adjunto) = UPPER('$nombre_adjunto')
and id != $id 
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */
        if (count($records) > 0) {
            $errors['mensaje'] = "Ya hay un registro con ese tipo documento $nombre_adjunto, por favor verificar.";
            $errors['servicio'] = "rvc_formato_pago_adj";
            $logger->info("Ya hay un registro con ese tipo documento $nombre_adjunto, por favor verificar.");
        }

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['usuario_log'] = $request['username'];
            $request['fecha_log'] = CN_TABLE::fechaSistema();
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
